﻿Public Class FOutput
    Dim colorn() As Color
    Dim bitmap As System.Drawing.Bitmap = New Bitmap(1, ClientSize.Height * 5 \ 4)
    Dim bmp As System.Drawing.Bitmap = New Bitmap(Me.ClientSize.Width, Me.ClientSize.Height)
    Dim gfi As System.Drawing.Graphics = Graphics.FromImage(bmp)

    Private Sub me_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        FPaint()
    End Sub

    Public Sub FPaint()
        rainbow()
        bmp.Dispose() : bmp = New Bitmap(ClientSize.Width, ClientSize.Height)
        gfi.Dispose() : gfi = Graphics.FromImage(bmp)
        Dim csw! = ClientSize.Width, csw2! = csw / 2
        Dim csh! = ClientSize.Height : Dim csh2! = (csh - 1) / 2
        Dim lgb As LinearGradientBrush = _
        New LinearGradientBrush(Me.ClientRectangle, Color.Black, Color.LawnGreen, 0, False)
        Dim Vanity_Pointx# = (Me.Width + Me.Location.X) / (My.Computer.Screen.Bounds.Width + Me.Width)
        lgb.SetBlendTriangularShape(CSng(1 - Vanity_Pointx))
        gfi.FillRectangle(lgb, Me.ClientRectangle)
        Dim cshphi = csh2 / Math.PI
        Dim max = 0.0
        Dim cswn! = csw / V.n, pw! = csw / V.n - 1
        For j As Integer = 0 To V.n
            Dim jwn! = j * cswn
            Dim vxr = V.o(0, j) : Dim vyi = V.o(1, j)
            Dim angle% = CInt(Math.Atan2(vyi, vxr) * cshphi + csh2)
            Dim vectorAmount = Math.Sqrt(vxr ^ 2 + vyi ^ 2)
            If vectorAmount > max Then max = vectorAmount
            Dim mybenearnull = 1.0#
            If vectorAmount <> 0.0# Then
                mybenearnull = Math.Log10(vectorAmount) / -Form1.ground.value
                If mybenearnull >= 1.0# Then mybenearnull = 1.0#
            End If
            If mybenearnull < 1.0# Then
                gfi.DrawLine(New Pen(Color.FromArgb(128, 255, 224, 128), pw), jwn, _
                CSng(mybenearnull * csh), jwn, csh)
                gfi.DrawLine(New Pen(colorn(angle), pw), jwn, _
                csh - CSng(vectorAmount * csh), jwn, csh)
            End If
        Next
        Text = "Output " + Format(max, "0.################")
        Me.CreateGraphics.DrawImage(bmp, 0, 0)

    End Sub

    Private Sub me_SizeChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.SizeChanged, MyBase.LocationChanged
        If Form1.enable = True Then FPaint()
    End Sub

    Private Sub rainbow()
        ReDim colorn(ClientSize.Height)
        bitmap.Dispose() : bitmap = New Bitmap(1, ClientSize.Height * 5 \ 4)
        gfi.Dispose() : gfi = Graphics.FromImage(bitmap)
        Dim rect As Rectangle = New Rectangle(0, 0, 1, ClientSize.Height * 5 \ 4)
        Using lgb As New LinearGradientBrush(rect, Color.Empty, Color.Empty, LinearGradientMode.Vertical)
            Dim cb As New ColorBlend(6)
            cb.Colors = New Color() {Color.Blue, Color.Red, Color.LawnGreen,
                                    Color.Yellow, Color.Blue, Color.Red}
            For i As Integer = 0 To 5
                cb.Positions(i) = i / 5.0!
            Next
            lgb.InterpolationColors = cb
            gfi.FillRectangle(lgb, rect)
        End Using
        For n = 0 To ClientSize.Height
            colorn(n) = bitmap.GetPixel(0, n + ClientSize.Height \ 8)
        Next
    End Sub

    Private Sub me_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Form1.OutputToolStripMenuItem1.Checked = False
    End Sub
End Class