﻿Public Class FVector
    Dim bmp As System.Drawing.Bitmap = New Bitmap(Me.ClientSize.Width, Me.ClientSize.Height)
    Dim gfi As System.Drawing.Graphics = Graphics.FromImage(bmp)
    Dim Screen_Size As Vector = New Vector(My.Computer.Screen.Bounds)
    Private Sub me_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Me.FPaint()
    End Sub

    Friend Sub FPaint()

        bmp.Dispose() : bmp = New Bitmap(Me.ClientSize.Width, Me.ClientSize.Height)
        gfi.Dispose() : gfi = Graphics.FromImage(bmp)
        Dim Me_Size As Vector = New Vector(Me)
        Dim Vanity_Point As Vector = (Me_Size + Location) / (Me_Size + Screen_Size)
        Dim Client_Size As Vector = New Vector(ClientSize)
        Dim gp As GraphicsPath = New GraphicsPath()
        gp.AddRectangle(Me.ClientRectangle)
        Dim pgb As PathGradientBrush = New PathGradientBrush(gp)
        pgb.CenterPoint = (1 - Vanity_Point) * Client_Size
        pgb.CenterColor = Color.Black
        pgb.SurroundColors = New Color() {Color.Red, Color.LawnGreen, Color.Yellow, Color.Blue}
        gfi.FillRectangle(pgb, Me.ClientRectangle)
        gp = New GraphicsPath
        gp.AddEllipse(Me.ClientRectangle)
        pgb = New PathGradientBrush(gp)
        pgb.CenterPoint = (1 - Vanity_Point) * Client_Size
        pgb.CenterColor = Color.Yellow
        pgb.SurroundColors = New Color() {(Color.Black)}
        gfi.FillRectangle(pgb, Me.ClientRectangle)
        Dim cshalf As Vector = (Client_Size) * 0.5
        gfi.TranslateTransform(cshalf.X, cshalf.Y)
        cshalf = cshalf / V.n2
        Dim centerpoint As Vector = New Vector(pgb.CenterPoint) / V.n2 - cshalf
        Dim j% = V.n
        Dim axis As Vector = centerpoint * j : Dim large As Vector = cshalf * (V.n2 - j)
        Dim pe As Pen = New Pen(Color.FromArgb(100, 100, 60))
        gfi.DrawEllipse(pe, axis.X - large.X, axis.Y - large.Y, large.X * 2, large.Y * 2)
        gfi.DrawLine(pe, axis.X, axis.Y - large.Y, axis.X, axis.Y + large.Y)
        gfi.DrawLine(pe, axis.X - large.X, axis.Y, axis.X + large.X, axis.Y)
        pe = New Pen(Color.FromArgb(128, 255, 255, 255), 1)
        pe.DashStyle = Drawing2D.DashStyle.Dot
        gfi.DrawLine(pe, 0, 0, axis.X, axis.Y)
        pe.DashStyle = Drawing2D.DashStyle.Solid
        For j = V.n To 0 Step -1
            axis = centerpoint * j : large = cshalf * (V.n2 - j)
            Dim vectorp As Vector = New Vector(V.o(0, j), V.o(1, j)) * large + axis
            gfi.DrawLine(Pens.White, axis.X, axis.Y, vectorp.X, vectorp.Y)
        Next : j += 1
        axis = centerpoint * j : large = cshalf * (V.n2 - j)
        pe.DashStyle = Drawing2D.DashStyle.Dash
        gfi.DrawLine(pe, axis.X, axis.Y - large.Y, axis.X, axis.Y + large.Y)
        gfi.DrawLine(pe, axis.X - large.X, axis.Y, axis.X + large.X, axis.Y)
        pe.Color = Color.Black
        pe.DashStyle = Drawing2D.DashStyle.Solid
        gfi.DrawEllipse(pe, axis.X - large.X, axis.Y - large.Y, large.X * 2, large.Y * 2)
        Me.CreateGraphics.DrawImage(bmp, 0, 0)
    End Sub

    Private Sub me_SizeChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.SizeChanged, MyBase.LocationChanged
        If Form1.enable = True Then FPaint()
    End Sub

    Private Sub me_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Form1.VectorToolStripMenuItem1.Checked = False
    End Sub
End Class