﻿Public Class Form1

    Dim bmp As System.Drawing.Bitmap = New Bitmap(Me.ClientSize.Width, Me.ClientSize.Height)
    Dim gfi As System.Drawing.Graphics = Graphics.FromImage(bmp)
    Dim Screen_Size As Vector = New Vector(My.Computer.Screen.Bounds)

    Dim gp As GraphicsPath = New GraphicsPath()
    Public vanitycolor As Color = Color.Blue
    Dim surroundcolor As Color = Color.Black
    Dim subp As New Subs
    Public enable As Boolean = False

   

    Private Sub me_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.numbers.Width = Me.ClientSize.Width
        Me.frequency.Width = Me.ClientSize.Width
        Me.fractal.Width = Me.ClientSize.Width
        Me.phase.Width = Me.ClientSize.Width
        Me.amplitude.Width = Me.ClientSize.Width
        Me.filter.Width = Me.ClientSize.Width
        Me.ground.Width = Me.ClientSize.Width
    End Sub

    Private Sub me_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        subp.Redimension(numbers.value) : subp.delta()
        Me.InputToolStripMenuItem1.Checked = True
        Me.VectorToolStripMenuItem1.Checked = True
        Me.OutputToolStripMenuItem1.Checked = True
        Me.Fpaint() : Me.Focus()
    End Sub

    Private Sub roll(ByRef txt As String) Handles numbers.roll, frequency.roll, fractal.roll, phase.roll, amplitude.roll, filter.roll, ground.roll
        Select Case txt
            Case "numbers" : My.Settings.numbers = Me.numbers.value : subp.Redimension(numbers.value) : Exit Select
            Case "frequency" : My.Settings.frequency = Me.frequency.value : Exit Select
            Case "fractal" : My.Settings.fractal = Me.fractal.value : Exit Select
            Case "phase" : My.Settings.phase = Me.phase.value : Exit Select
            Case "amplitude" : My.Settings.amplitude = Me.amplitude.value : Exit Select
            Case "filter" : My.Settings.filter = Me.filter.value : subp.makefiltertable() : Exit Select
            Case "ground" : My.Settings.ground = Me.ground.value : Exit Select
        End Select
        subp.delta()
    End Sub

    Private Sub Fpaint()
        bmp.Dispose() : bmp = New Bitmap(Me.ClientSize.Width, Me.ClientSize.Height)
        gfi.Dispose() : gfi = Graphics.FromImage(bmp)
        gp.AddRectangle(Me.ClientRectangle)
        Dim pgb As PathGradientBrush = New PathGradientBrush(gp)
        Dim Me_Size As Vector = New Vector(Me)
        Dim Vanity_Point As Vector = (Me_Size + Location) / (Me_Size + Screen_Size)
        Vanity_Point = (1 - Vanity_Point)
        pgb.CenterPoint = New PointF(CSng(Vanity_Point.X * ClientSize.Width), _
                                         CSng(Vanity_Point.Y * ClientSize.Height))
        pgb.CenterColor = Me.vanitycolor : pgb.SurroundColors = New Color() {surroundcolor}
        gfi.FillRectangle(pgb, Me.ClientRectangle)
        Me.BackgroundImage = bmp
    End Sub

    Private Sub InputToolStripMenuItem1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InputToolStripMenuItem1.CheckStateChanged
        If Me.InputToolStripMenuItem1.Checked = True Then
            FInput.Enabled = True : FInput.Show()
        Else : FInput.Enabled = False : FInput.Hide()
        End If
    End Sub

    Private Sub OutputToolStripMenuItem1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OutputToolStripMenuItem1.CheckStateChanged
        If Me.OutputToolStripMenuItem1.Checked = True Then
            FOutput.Enabled = True : FOutput.Show()
        Else : FOutput.Enabled = False : FOutput.Hide()
        End If
    End Sub

    Private Sub VectorToolStripMenuItem1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VectorToolStripMenuItem1.CheckStateChanged
        If Me.VectorToolStripMenuItem1.Checked = True Then
            FVector.Enabled = True : FVector.Show()
        Else : FVector.Enabled = False : FVector.Hide()
        End If
    End Sub

    Private Sub ReloadToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReloadToolStripMenuItem.Click
        My.Settings.Reload()
    End Sub

    Private Sub RearrangeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RearrangeToolStripMenuItem.Click
        Me.SetBounds(Me.Location.X, Me.Location.Y, 256 + My.Settings.borderwidth, 256 + My.Settings.borderhight)
        FInput.SetBounds(Me.Location.X, Me.Location.Y - Me.Size.Height, 256 + My.Settings.borderwidth, 256 + My.Settings.borderhight) : FInput.FPaint()
        FOutput.SetBounds(Me.Location.X + Me.Size.Width, Me.Location.Y - Me.Size.Height, 256 + My.Settings.borderwidth, 256 + My.Settings.borderhight) : FOutput.FPaint()
        FVector.SetBounds(Me.Location.X + Me.Size.Width, Me.Location.Y, 256 + My.Settings.borderwidth, 256 + My.Settings.borderhight) : FVector.FPaint()
    End Sub

    Private Sub ResetToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ResetToolStripMenuItem.Click
        Me.numbers.Timer1.Stop()
        Me.frequency.Timer1.Stop()
        Me.fractal.Timer1.Stop()
        Me.phase.Timer1.Stop()
        Me.amplitude.Timer1.Stop()
        Me.filter.Timer1.Stop()
        Me.ground.Timer1.Stop()
        My.Settings.Reset()
    End Sub

    Private Sub me_SizeChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.SizeChanged, MyBase.LocationChanged
        Fpaint()
    End Sub

    Private Sub me_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        My.Settings.Save()
    End Sub
End Class
