﻿Public Class Vector

    Public Sub New()
    End Sub
    Public Sub New(ByVal initX As Integer, ByVal initY As Integer)
        X = initX : Y = initY : Width = X : Height = Y
    End Sub
    Public Sub New(ByVal initX As Single, ByVal initY As Single)
        X = initX : Y = initY : Width = X : Height = Y
    End Sub
    Public Sub New(ByVal initx As Double, ByVal inity As Double)
        X = CSng(initx) : Y = CSng(inity) : Width = X : Height = Y
    End Sub
    Public Sub New(ByVal init As Vector)
        X = init.X : Y = init.Y
    End Sub

    Public Sub New(ByVal init As PointF)
        X = init.X : Y = init.Y
    End Sub

    Public Sub New(ByVal init As Form)
        X = init.Width : Y = init.Height
    End Sub

    Public Sub New(ByVal init As Rectangle)
        X = init.Width : Y = init.Height
    End Sub
    Public Sub New(ByVal init As System.Drawing.Size)
        X = init.Width : Y = init.Height : Width = init.Width : Height = init.Height
    End Sub



    ' ------------------------------ 
    ' Öffentliche Elemente 
    ' ------------------------------ 
    Public X As Single
    Public Y As Single
    Public Width As Single
    Public Height As Single
    'Public ReadOnly Property Betrag() As Double
    '    ' Liefert den Betrag des Vectors 
    '    Get
    '        Return System.Math.Sqrt(Math.Pow(X, 2) + Math.Pow(Y, 2))
    '    End Get
    'End Property

    'Public Overrides Function ToString() As String
    '    ' Stringdarstellung (überschreibt Object.ToString) 
    '    Return String.Format("({0};{1})", X, Y)
    'End Function

    'Public Overrides Function Equals(ByVal obj As Object) As Boolean
    '    ' Inhaltsgleichheit (überschreibt Object.Equals) 
    '    If TypeOf obj Is Vector Then
    '        Return (CType(obj, Vector).X = X AndAlso CType(obj, Vector).Y = Y)
    '    End If
    'End Function

    Public Shared Operator +(ByVal VectorA As Vector, ByVal VectorB As Vector) As Vector
        ' Addition zweier zweidimensionaler Vectoren. 
        Return New Vector(VectorA.X + VectorB.X, VectorA.Y + VectorB.Y)
    End Operator

    Public Shared Operator +(ByVal VectorA As PointF, ByVal VectorB As Vector) As Vector
        ' Addition zweier zweidimensionaler Vectoren. 
        Return New Vector(VectorA.X + VectorB.X, VectorA.Y + VectorB.Y)
    End Operator

    Public Shared Operator +(ByVal VectorA As Vector, ByVal VectorB As PointF) As Vector
        ' Addition zweier zweidimensionaler Vectoren. 
        Return New Vector(VectorA.X + VectorB.X, VectorA.Y + VectorB.Y)
    End Operator

    Public Shared Operator -(ByVal VectorA As Vector, ByVal VectorB As Vector) As Vector
        Return New Vector(VectorA.X - VectorB.X, VectorA.Y - VectorB.Y)
    End Operator


    Public Shared Operator -(ByVal VectorB As Vector, ByVal ganzzahl As Integer) As Vector
        Return New Vector(ganzzahl - VectorB.X, ganzzahl - VectorB.Y)
    End Operator
    Public Shared Operator -(ByVal ganzzahl As Integer, ByVal VectorB As Vector) As Vector
        Return New Vector(ganzzahl - VectorB.X, ganzzahl - VectorB.Y)
    End Operator

    Public Shared Operator *(ByVal VectorA As Vector, ByVal VectorB As Vector) As PointF
        Return New PointF(VectorA.X * VectorB.X, VectorA.Y * VectorB.Y)
    End Operator

    Public Shared Operator *(ByVal VectorA As Vector, ByVal Factor As Single) As Vector
        Return New Vector(VectorA.X * Factor, VectorA.Y * Factor)
    End Operator

    Public Shared Operator *(ByVal VectorA As Vector, ByVal VectorB As PointF) As PointF
        Return New PointF(VectorA.X * VectorB.X, VectorA.Y * VectorB.Y)
    End Operator
   


    Public Shared Operator /(ByVal VectorA As Vector, ByVal VectorB As Vector) As Vector
        Return New Vector(VectorA.X / VectorB.X, VectorA.Y / VectorB.Y)
    End Operator

    Public Shared Operator /(ByVal VectorA As Vector, ByVal factor As Single) As Vector
        Return New Vector(VectorA.X / factor, VectorA.Y / factor)
    End Operator

    ' Nützliche CType-Überladung für Prompt-Ausgaben (z.B. MsgBox): 

    'Public Shared Widening Operator CType(ByVal VectorA As Vector) As String
    '    Return (VectorA.ToString)
    'End Operator

End Class
