﻿
Namespace My

    'Diese Klasse ermöglicht die Behandlung bestimmter Ereignisse der Einstellungsklasse:
    ' Das SettingChanging-Ereignis wird ausgelöst, bevor der Wert einer Einstellung geändert wird.
    ' Das PropertyChanged-Ereignis wird ausgelöst, nachdem der Wert einer Einstellung geändert wurde.
    ' Das SettingsLoaded-Ereignis wird ausgelöst, nachdem die Einstellungswerte geladen wurden.
    ' Das SettingsSaving-Ereignis wird ausgelöst, bevor die Einstellungswerte gespeichert werden.
    Partial Friend NotInheritable Class MySettings

        Dim testform As Form = New Form
        Private Sub MySettings_SettingsLoaded(ByVal sender As Object, ByVal e As System.Configuration.SettingsLoadedEventArgs) Handles Me.SettingsLoaded
            Dim borderx = (testform.Size.Width - testform.ClientSize.Width) - borderwidth
            Dim bordery = (testform.Size.Height - testform.ClientSize.Height) - borderhight

            If borderx <> 0 Or bordery <> 0 Then

                FinputLocation = New Point(FinputLocation.X, FinputLocation.Y)
                FOutputLocation = New Point(FOutputLocation.X + borderx, FOutputLocation.Y)
                FVectorLocation = New Point(FVectorLocation.X + borderx, FVectorLocation.Y + bordery)
                Form1Location = New Point(Form1Location.X, Form1Location.Y + bordery)

                borderwidth = (testform.Size.Width - testform.ClientSize.Width)
                borderhight = (testform.Size.Height - testform.ClientSize.Height)
            End If

            testform.Dispose()
            Save()
        End Sub
    End Class


End Namespace
