﻿Public Class Subs
    Public Sub Redimension(ByVal m As Integer)
        V.m = m
        V.n = CInt(4 ^ m)
        V.nh = V.n \ 2
        V.nd = V.n - 1
        V.n2 = V.n * 2
        ReDim Preserve V.wsin(V.n2), V.wcos(V.n2), V.wfilt(V.n2)
        makeangletable()
        makefiltertable()
        ReDim Preserve V.bit(V.n)
        makeinverstable()
        ReDim Preserve V.x(1, V.n), V.y(1, V.n), V.xr(1, V.nh), V.yi(1, V.nh), V.o(1, V.n)
        If Form1.frequency.value > V.n Then
            Form1.frequency.value = _
            CInt(Math.Truncate(Form1.frequency.value / (Form1.frequency.maximum - (Form1.frequency.large_change - 1)) * V.n))
        End If
        Form1.frequency.maximum = V.n + 9
        Form1.frequency.Label3.Text = CStr(V.n)
    End Sub

    Public Sub delta()

        Dim ff& = Form1.frequency.value * 180 + Form1.fractal.value
        Dim fp& = (Form1.phase.value + 90) * V.n
        Dim modulus& = V.n * 360

        Dim fa# = Form1.amplitude.value / 100
        Dim delta# = Math.PI / V.n / 180

        For j% = 0 To V.n2
            V.x(j And 1, j \ 2) = Math.Sin(delta * (((j - V.n) * ff - fp) Mod modulus)) * fa * V.wfilt(j)
        Next

        V.y = CType(V.x.Clone(), Double(,))
        Swapping() : fft() : Separation() : Julian()
        Form1.enable = True
    End Sub

        Public Sub makefiltertable()
        Dim sum# = 0.0# : Dim filt# = (Form1.filter.value / Form1.filter.mode)

        For j = 0 To V.nd
            sum += Math.Sin(Math.PI * j / V.n) ^ filt
        Next
        V.cf = V.n / sum
        For j% = 0 To V.n
            V.wfilt(j) = Math.Sin(Math.PI * j / V.n2) ^ filt * V.cf
            V.wfilt(V.n2 - j) = V.wfilt(j)
        Next
    End Sub

        Public Sub makeinverstable()
        Dim M1% = V.m + V.m - 1, j% = 0, k% = 0, jn% = 0
        For j = 0 To V.nd : jn% = j : V.bit(j) = 0 'making table
            For k = 0 To M1 'reversion
                V.bit(j) = V.bit(j) * 2 + (jn And 1%)
                jn \= 2
            Next k
        Next j
        End Sub

        Public Sub makeangletable()
        Dim ms# : Dim vn3% = V.nh + V.n
        For j As Integer = 0 To V.nh
            ms = Math.Sin(Math.PI * j / V.n)
            V.wsin(j) = ms : V.wsin(V.n - j) = ms : V.wsin(V.n + j) = -ms : V.wsin(V.n2 - j) = -ms
            V.wcos(V.nh - j) = ms : V.wcos(V.nh + j) = -ms : V.wcos(vn3 - j) = -ms : V.wcos(vn3 + j) = ms
        Next
    End Sub

        Public Sub Swapping()
        For j As Integer = 0 To V.nd
            V.y(0, j) = V.x(0, V.bit(j))
            V.y(1, j) = V.x(1, V.bit(j))
        Next j
        End Sub

        Public Sub fft()
            Dim xR0#, xR1#, xR2#, xR3#, xI0#, xI1#, xI2#, xI3#
            Dim Angle0%, Angle1%, Angle2%, Angle3%
            Dim Index0%, Index1%, Index2%, Index3%
        Dim Mh% = V.m - 1
        Dim Indexstep% = 1
        Dim iMh%, Angle%, IAngle!, Anglestep!
        For iMh = 0 To Mh
            IAngle = 0
            Angle = V.nh \ Indexstep
            Anglestep! = CSng(2 / Angle)
            Index3 = -Indexstep
            Do
                Index0 = (Index3 + Indexstep) Mod V.nd : Index1 = Index0 + Indexstep
                Index2 = (Index1 + Indexstep) Mod V.nd : Index3 = Index2 + Indexstep
                xR0 = V.y(0, Index0) : xI0 = V.y(1, Index0)
                Angle0 = CInt(Math.Truncate(IAngle))
                If Angle0 <> 0% Then
                    Angle1 = Angle0 * Angle
                    xR2 = V.y(0, Index2) * V.wcos(Angle1) + V.y(1, Index2) * V.wsin(Angle1)
                    xI2 = V.y(1, Index2) * V.wcos(Angle1) - V.y(0, Index2) * V.wsin(Angle1)
                    Angle2 = Angle1 + Angle1
                    xR1 = V.y(0, Index1) * V.wcos(Angle2) + V.y(1, Index1) * V.wsin(Angle2)
                    xI1 = V.y(1, Index1) * V.wcos(Angle2) - V.y(0, Index1) * V.wsin(Angle2)
                    Angle3 = Angle2 + Angle1
                    xR3 = V.y(0, Index3) * V.wcos(Angle3) + V.y(1, Index3) * V.wsin(Angle3)
                    xI3 = V.y(1, Index3) * V.wcos(Angle3) - V.y(0, Index3) * V.wsin(Angle3)
                Else
                    xR1 = V.y(0, Index1) : xI1 = V.y(1, Index1)
                    xR2 = V.y(0, Index2) : xI2 = V.y(1, Index2)
                    xR3 = V.y(0, Index3) : xI3 = V.y(1, Index3)
                End If
                V.y(0, Index0) = xR0 + xR1 + xR2 + xR3 : V.y(1, Index0) = xI0 + xI1 + xI2 + xI3
                V.y(0, Index1) = xR0 - xR1 + xI2 - xI3 : V.y(1, Index1) = xI0 - xI1 - xR2 + xR3
                V.y(0, Index2) = xR0 + xR1 - xR2 - xR3 : V.y(1, Index2) = xI0 + xI1 - xI2 - xI3
                V.y(0, Index3) = xR0 - xR1 - xI2 + xI3 : V.y(1, Index3) = xI0 - xI1 + xR2 - xR3
                IAngle += Anglestep
            Loop Until Index3 = V.nd
            Indexstep *= 4
        Next iMh

    End Sub

        Public Sub Separation()
        Dim m25 As Double = 0.25 ^ V.m
        V.y(0, V.n) = V.y(0, 0) : V.y(1, V.n) = V.y(1, 0)
        Dim j% = V.nh : Dim k% = V.nh
        Do
            V.xr(0, j) = (V.y(0, j) + V.y(0, k)) * m25
            V.yi(0, j) = (V.y(1, j) - V.y(1, k)) * m25
            V.xr(1, j) = (V.y(1, j) + V.y(1, k)) * m25
            V.yi(1, j) = (V.y(0, k) - V.y(0, j)) * m25
            j -= 1 : k += 1
        Loop While j >= 0
    End Sub

        Public Sub Julian()
        Dim j% = V.nh, k% = V.n - j%
        Dim sign As Boolean = True
        Do
            Dim Xr# = V.xr(1, j) * V.wcos(j) + V.yi(1, j) * V.wsin(j)
            Dim Yi# = V.yi(1, j) * V.wcos(j) - V.xr(1, j) * V.wsin(j)
            sign = Not sign
            If sign = True Then
                V.o(1, k) = -(V.xr(0, j) - Xr) / 2
                V.o(0, k) = (V.yi(0, j) - Yi) / 2
                V.o(1, j) = -(V.xr(0, j) + Xr) / 2
                V.o(0, j) = -(V.yi(0, j) + Yi) / 2
            Else
                V.o(1, k) = (V.xr(0, j) - Xr) / 2
                V.o(0, k) = -(V.yi(0, j) - Yi) / 2
                V.o(1, j) = (V.xr(0, j) + Xr) / 2
                V.o(0, j) = (V.yi(0, j) + Yi) / 2

            End If

            j -= 1 : k += 1
        Loop While j >= 0
        FInput.FPaint() : FOutput.FPaint() : FVector.FPaint()
    End Sub

End Class
